package pmicrovenus;

import java.io.Serializable;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.swing.JOptionPane;

@Entity
public class CartaIngreso extends Baraja implements Serializable{
    
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;
    
    private float dinero;
    private int tipoCarta;
    private String etiqueta;

    public CartaIngreso() {
    }
    
    public CartaIngreso(String Etiqueta, float dinero, int tipo){
        this.etiqueta = Etiqueta;
        this.dinero = dinero;
        this.tipoCarta = tipo;
    }

    @Override
    public void aplicaAccion(Tablero t) {

        String mens;
        if (tipoCarta==Baraja.CARTA_COMUNIDAD) mens ="CARTA COMUNIDAD\n\n" + getEtiqueta() + "\nCOBRAS " + dinero + " ";
        else mens ="CARTA SUERTE\n\n" + getEtiqueta() + "\nCOBRAS " + dinero + " ";
        String tit = t.getJugadorActual().getNombre();
        JOptionPane.showMessageDialog(null,mens,tit,JOptionPane.INFORMATION_MESSAGE);
        //Accion
        t.getJugadorActual().ingreso(dinero);
        
    }

    @Override
    public int getTipoCarta() {
        return tipoCarta;
    }

    @Override
    public String getEtiqueta() {
        return etiqueta;
    }

    @Override
    public boolean isLibre() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    
    public void aplicaAccion(Jugador j) {
        throw new UnsupportedOperationException("Not supported yet.");
    }
    
    
     public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }
    
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof CartaIngreso)) {
            return false;
        }
        CartaIngreso other = (CartaIngreso)object;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) return false;
        return true;
    }

    @Override
    public String toString() {
        String res = "CartaIngreso(" + id + ")";
        return res;
    }
           
}
